#lang racket

(require rackunit)
(require "session06.rkt")

(define ucsb '("University" "of" "California" "at" "Santa" "Barbara"))
(define uni  '("University" "of" "Northern" "Iowa"))

; BEFORE   ---------------------------------------------------------

(check-equal? (acronym ucsb) "UoCaSB")
(check-equal? (acronym uni)  "UoNI")

; A NEW IDEA    ----------------------------------------------------

(define *words-to-drop* '("of" "at" "the" "in"))

(define significant-word?
  (lambda (word)
    (not (member word *words-to-drop*))))

(check-equal? (filter significant-word? ucsb)
              '("University" "California" "Santa" "Barbara"))

; AFTER    ---------------------------------------------------------

(check-equal? (acronym (filter significant-word? ucsb))
              "UCSB")
(check-equal? (acronym (filter significant-word? uni))
              "UNI")

; NEXT STEP    -----------------------------------------------------
;
; We can use (filter significant-word? ...) in our acronym function
; so that it skips any droppable words before doing its job.
; Give it a try!
